SystemOrganization addCategory: #'Talk-Core'!
SystemOrganization addCategory: #'Talk-Tests'!

Object subclass: #Executor
	instanceVariableNames: 'methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Talk-Core'!

!Executor methodsFor: 'execution' stamp: 'chaetal 11/17/2012 11:44'!
executeNextMessageFrom: aMessageStream
	| nextMessage |
	nextMessage := aMessageStream get.
	^ methods findAndExecute: nextMessage! !

!Executor methodsFor: 'accessing' stamp: 'chaetal 11/17/2012 11:46'!
methods: aMethods
	methods := aMethods ! !

Object subclass: #ObjectSystem
	instanceVariableNames: 'executor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Talk-Core'!

!ObjectSystem methodsFor: 'accessing' stamp: 'chaetal 11/16/2012 07:04'!
defaultExecutor: anExecutor
	executor := anExecutor! !

!ObjectSystem methodsFor: 'execution' stamp: 'chaetal 11/17/2012 11:38'!
execute: programStream
	^ executor executeNextMessageFrom: programStream! !

TestCase subclass: #ExecutorTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Talk-Tests'!

!ExecutorTests methodsFor: 'tests' stamp: 'chaetal 11/17/2012 11:45'!
testEctractsAndExecutesNextMessageFromStream
	| executor actualResult |
	executor := Executor new.
	[ :stream :methods | 
	executor methods: methods.
	[ actualResult := executor executeNextMessageFrom: stream ] should strictly
		satisfy: [ 
			stream get willReturn: #nextMessage.
			(methods findAndExecute: #nextMessage) willReturn: #resultObject ].
	actualResult should be: #resultObject ] runScenario! !

TestCase subclass: #ObjectSystemTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Talk-Tests'!

!ObjectSystemTests methodsFor: 'tests' stamp: 'chaetal 11/17/2012 11:35'!
testSimple
	| objectSystem actualResult |
	[ :executor | 
	objectSystem := ObjectSystem new.
	objectSystem defaultExecutor: executor.
	[ actualResult := objectSystem execute: #programStream ] should strictly
		satisfy: [ (executor executeNextMessageFrom: #programStream) willReturn: #resultObject ].
	actualResult should be: #resultObject ] runScenario! !
